<template>
    <main id="js-page-content" role="main" class="page-content">
        <ol class="breadcrumb page-breadcrumb">
            <li class="breadcrumb-item"> <router-link to="/index">Dashboard</router-link> </li>
            <li class="breadcrumb-item"> <router-link to="/users">Users</router-link></li>
            <li class="breadcrumb-item active"> User Detail</li>
        </ol>
        <div class="subheader">
            <h1 class="subheader-title">
                <i class='subheader-icon fal fa-user'></i> User detail<span class='fw-300'></span>
            </h1>
            <div v-if="findPermission('profile','updateAny') || role=='admin'" class="subheader-block d-lg-flex align-items-center border-faded border-right-0 border-top-0 border-bottom-0 ml-3 pl-3">
                <div class="d-inline-flex flex-column justify-content-center">
                    <button class="btn btn-primary" data-toggle="modal" data-target="#editModal">
                        <i class="fas fa-user-edit mr-2"></i> Edit User Detail
                    </button>
                </div>
                <span class="sparklines hidden-lg-down" sparkType="bar" sparkBarColor="#fe6bb0" sparkHeight="32px" sparkBarWidth="5px" values="1,4,3,6,5,3,9,6,5,9,7"></span>
            </div>
            <div v-if="findPermission('profile','deleteAny') || role=='admin'" class="subheader-block d-lg-flex align-items-center border-faded border-right-0 border-top-0 border-bottom-0 ml-3 pl-3">
                <div class="d-inline-flex flex-column justify-content-center">
                    <button class="btn btn-danger" @click="deleteUser()">
                        <i class="fas fa-user-minus mr-2"></i> Delete User
                    </button>
                </div>
                <span class="sparklines hidden-lg-down" sparkType="bar" sparkBarColor="#fe6bb0" sparkHeight="32px" sparkBarWidth="5px" values="1,4,3,6,5,3,9,6,5,9,7"></span>
            </div>
            <div v-if="findPermission('profile','updateAny') || role=='admin'" class="subheader-block d-lg-flex align-items-center border-faded border-right-0 border-top-0 border-bottom-0 ml-3 pl-3">
                <div class="d-inline-flex flex-column justify-content-center">
                    <button class="btn btn-warning" @click="deactivateUser()">
                        <i class="fas fa-user-slash mr-2"></i> Deactivate User
                    </button>
                </div>
                <span class="sparklines hidden-lg-down" sparkType="bar" sparkBarColor="#fe6bb0" sparkHeight="32px" sparkBarWidth="5px" values="1,4,3,6,5,3,9,6,5,9,7"></span>
            </div>
            <div v-if="findPermission('profile','updateAny') || role=='admin'" class="subheader-block d-lg-flex align-items-center border-faded border-right-0 border-top-0 border-bottom-0 ml-3 pl-3">
                <div class="d-inline-flex flex-column justify-content-center">
                    <button class="btn btn-info" data-toggle="modal" data-target="#pwdModal">
                        <i class="fas fa-lock mr-2"></i> Change Password
                    </button>
                </div>
                <span class="sparklines hidden-lg-down" sparkType="bar" sparkBarColor="#fe6bb0" sparkHeight="32px" sparkBarWidth="5px" values="1,4,3,6,5,3,9,6,5,9,7"></span>
            </div>
        </div>

        <div v-if="!empty" class="row">
            <div class="col-lg-7 col-xl-7 col-md-7" >
                <!-- profile summary -->
                <div class="card mb-g rounded-top">
                    <div class="row no-gutters row-grid">
                        <div class="col-12">
                            <div class="d-flex flex-column align-items-center justify-content-center p-4">
                                <img src="https://www.gravatar.com/avatar/205e460b479e2e5b48aec07710c08d50" class="rounded-circle shadow-2 img-thumbnail" alt="">
                                <h3 class="mb-0 fw-700 text-center mt-3">
                                    {{user.firstName+" "+user.lastName}}
                                    <h4 class="mb-3 fw-700 text-center mt-2">
                                        {{user.username}}
                                    </h4>
                                    <small class="text-muted mb-0"><span class="d-inline-block mr-1" :class="user.status=='Active'?'text-success':''" width="10px"><i class="fas fa-circle"></i></span>{{user.status}}</small>
                                </h3>
                            </div>
                        </div>
                        <div class="col-6">
                            <div class="text-center py-3">
                                <h5 class="mb-0 fw-700">
                                    <small class="text-muted mb-3">Phone number</small>
                                    {{user.phone}}
                                </h5>
                            </div>
                        </div>
                        <div class="col-6">
                            <div class="text-center py-3">
                                <h5 class="mb-0 fw-700">
                                    <small class="text-muted mb-3">User Type</small>
                                    {{user.role}}
                                </h5>
                            </div>
                        </div>
                        <div class="col-6">
                            <div class="text-center py-3">
                                <h5 class="mb-0 fw-700">
                                    <small class="text-muted mb-3">Date of birth</small>
                                    {{user.dob | cut_date}}
                                </h5>
                            </div>
                        </div>
                        <div class="col-6">
                            <div class="text-center py-3">
                                <h5 class="mb-0 fw-700">
                                    <small class="text-muted mb-3">Gender</small>
                                    {{user.gender}}
                                </h5>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-xl-12 col-md-5">
                <div id="panel-1" class="panel">
                    <div class="panel-hdr">
                        <h2>
                            Devices currently <span class="fw-300"><i>logged in from:</i></span>
                        </h2>
                        <div class="panel-toolbar">
                            <button class="btn btn-panel" data-action="panel-collapse" data-toggle="tooltip" data-offset="0,10" data-original-title="Collapse"></button>
                            <button class="btn btn-panel" data-action="panel-fullscreen" data-toggle="tooltip" data-offset="0,10" data-original-title="Fullscreen"></button>
                        </div>
                    </div>
                    <div class="panel-container show">
                        <div class="panel-content">
                            <!-- datatable start -->
                            <table id="dt-basic-example" class="table table-bordered table-hover table-striped w-100">
                                <thead>
                                    <tr>
                                        <th>S.N.</th>
                                        <th>Device name</th>
                                        <th>Location</th>
                                        <th>Status</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-for="(device,index) in devices" :key="index">
                                        <td>{{index+1}}</td>
                                        <td>{{device.device_name}}</td>
                                        <td>{{device.location}}</td>
                                        <td>{{device.status}}</td>
                                    </tr>
                                </tbody>
                            </table>
                            <!-- datatable end -->
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- edit modal -->
        <div class="modal fade" id="editModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLongTitle">Edit user</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <!-- name -->
                    <div class="form-group row">
                        <label class="col-xl-12 form-label" for="firstName">Full name</label>
                        <div class="col-6 pr-1">
                            <input type="text" v-model="user.firstName" name="firstName" class="form-control" 
                                :class="{ 'is-invalid': user.errors.has('firstName') }" id="firstName" 
                                placeholder="First Name" value="" required>
                            <has-error :form="user" field="firstName"></has-error>
                        </div>
                        <div class="col-6 pl-1">
                            <input type="text" v-model="user.lastName" name="lastName" class="form-control" 
                                :class="{ 'is-invalid': user.errors.has('lastName') }" id="lastName" 
                                placeholder="Last Name" value="" required>
                            <has-error :form="user" field="lastName"></has-error>
                        </div>
                    </div>
                    <!-- email -->
                    <div class="form-group">
                        <label class="form-label" for="username">Email</label> <span style="color:red;">*</span>
                        <input type="email" v-model="user.username" name="username" class="form-control" 
                            :class="{ 'is-invalid': user.errors.has('username') }" id="username" 
                            placeholder="Enter your email" value="">
                        <has-error :form="user" field="username"></has-error>
                    </div>
                    <!-- phone -->
                    <div class="form-group">
                        <label class="form-label" for="phone">Phone number</label>
                        <input type="text" v-model="user.phone" name="phone" class="form-control" 
                            :class="{ 'is-invalid': user.errors.has('phone') }" id="phone" 
                            placeholder="Phone number" value="" required>
                        <has-error :form="user" field="phone"></has-error>
                    </div>
                    <!-- status -->
                    <div class="form-group">
                        <label class="form-label" for="status">Status</label>
                        <select v-model="user.status" name="status" class="form-control" 
                            :class="{ 'is-invalid': user.errors.has('status') }" id="status">
                            <option value="Active">Active</option>
                            <option value="Deactive">Inactive</option>
                        </select>
                    </div>
                    <!-- date of birth -->
                    <div class="form-group">
                        <label class="form-label" for="dob">Date of birth</label>
                        <input type="date" v-model="user.dob" name="dob" class="form-control text-muted" 
                            :class="{ 'is-invalid': user.errors.has('dob') }" id="dob" 
                            value="" required>
                        <has-error :form="user" field="dob"></has-error>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary" data-dismiss="modal" @click="editUser()">Save changes</button>
                </div>
                </div>
            </div>
        </div>

        <!-- change password modal -->
        <div class="modal fade" id="pwdModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLongTitle">Change Password</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <!-- current password -->
                    <div class="form-group">
                        <label class="form-label" for="current_password">Current password</label>
                        <input type="password" v-model="pwd.current_password" name="current_password" class="form-control" 
                            :class="{ 'is-invalid': pwd.errors.has('current_password') }" id="current_password" 
                             value="" required>
                        <has-error :form="pwd" field="current_password"></has-error>
                    </div>
                    <!-- new password -->
                    <div class="form-group">
                        <label class="form-label" for="new_password">New password</label>
                        <input type="password" v-model="pwd.new_password" name="new_password" class="form-control" 
                            :class="{ 'is-invalid': pwd.errors.has('new_password') }" id="new_password" 
                             value="" required>
                        <has-error :form="pwd" field="new_password"></has-error>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary" data-dismiss="modal" @click="changePassword">Save changes</button>
                </div>
                </div>
            </div>
        </div>
    </main>
</template>

<script>
import axios from 'axios'
    export default {
        filters: {
            cut_date: function(value) {
                if (!value) return ''
                value = value.substring(0, 10)
                return value
            }
        },
        name: 'UserDetail',
        data() {
            return {
                empty:true,
                user: new this.$Form( {
                    id: '',
                    status: '',
                    username: '',
                    firstName:'',
                    lastName:'',
                    phone:'',
                    dob:'',
                    role:'',
                    gender:''
                }),
                pwd: new this.$Form({
                    username:'',
                    current_password:'',
                    new_password:''
                }),
                devices:[],
                role:''
            }
        },
        methods: {
            fetchUser() {
                this.$store.dispatch('user/userDetail', this.$route.params.id)
                .then(() => {
                    this.user.fill(this.$store.getters['user/user'])
                    this.empty = false
                    this.fetchDevices()
                })
            },
            fetchDevices(){
                this.$store.dispatch('device/userDevice', this.user.username)
                .then(() => {
                    this.devices = this.$store.getters['device/user_devices']
                })
            },
            editUser() {
                this.user.id = this.$route.params.id
                this.$store.dispatch('user/editUser', this.user)
                .then(() => {
                    this.fetchUser()
                    this.$router.push('/users')
                })
            },
            deleteUser() {
                this.$Swal.fire({
                    title: 'Are you sure?',
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Yes, delete it!',
                    showLoaderOnConfirm: true,
                    preConfirm: () => {
                        this.$store.dispatch('user/deleteUser', this.$route.params.id)
                        .then(() => {
                            this.$router.push('/users')
                        })
                    }
                })                
            },
            deactivateUser() {
                this.$Swal.fire({
                    title: 'Are you sure?',
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Yes',
                    showLoaderOnConfirm: true,
                    preConfirm: () => {
                        this.$store.dispatch('user/deactivateUser', this.$route.params.id)
                        .then(() => {
                            this.$router.push('/users')
                        })
                    }
                })                
            },
            async changePassword() {
                this.pwd.username = this.user.username
                await axios.put("http://ec2-54-89-84-11.compute-1.amazonaws.com:3000/api/user/password/reset", this.pwd,
                {
                    headers: {
                        'Authorization': `Bearer ${localStorage.getItem('accessToken')}`
                    }
                })
                .then(()=>{
                    this.$Toast.fire({
                        icon: 'success',
                            title: 'Password changed successfully'
                        })
                    this.$$('#pwdModal').modal('hide')
                })
            },
            findPermission(resource,action){
                if(this.role!='user' && this.role!='admin'){
                    if(this.role.permissions.find(item => item.resource == resource && item.action == action)){
                        return true
                    }
                    else{
                        return false
                    }
                }
            }
        },
        created(){
            this.fetchUser()
            this.role = JSON.parse(localStorage.getItem("role"))
        }   
    }
</script>

<style scoped>

</style>
